/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"fmt"
)

// MessengerTag the model 'MessengerTag'
type MessengerTag string

// List of MessengerTag
const (
	MESSENGER_TAG_NONE MessengerTag = "NONE"
	MESSENGER_TAG_ACCOUNT_UPDATE MessengerTag = "ACCOUNT_UPDATE"
	MESSENGER_TAG_CONFIRMED_EVENT_UPDATE MessengerTag = "CONFIRMED_EVENT_UPDATE"
	MESSENGER_TAG_POST_PURCHASE_UPDATE MessengerTag = "POST_PURCHASE_UPDATE"
	MESSENGER_TAG_HUMAN_AGENT MessengerTag = "HUMAN_AGENT"
	MESSENGER_TAG_CUSTOMER_FEEDBACK MessengerTag = "CUSTOMER_FEEDBACK"
)

// All allowed values of MessengerTag enum
var AllowedMessengerTagEnumValues = []MessengerTag{
	"NONE",
	"ACCOUNT_UPDATE",
	"CONFIRMED_EVENT_UPDATE",
	"POST_PURCHASE_UPDATE",
	"HUMAN_AGENT",
	"CUSTOMER_FEEDBACK",
}

func (v *MessengerTag) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := MessengerTag(value)
	for _, existing := range AllowedMessengerTagEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid MessengerTag", value)
}

// NewMessengerTagFromValue returns a pointer to a valid MessengerTag
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewMessengerTagFromValue(v string) (*MessengerTag, error) {
	ev := MessengerTag(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for MessengerTag: valid values are %v", v, AllowedMessengerTagEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v MessengerTag) IsValid() bool {
	for _, existing := range AllowedMessengerTagEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to MessengerTag value
func (v MessengerTag) Ptr() *MessengerTag {
	return &v
}

type NullableMessengerTag struct {
	value *MessengerTag
	isSet bool
}

func (v NullableMessengerTag) Get() *MessengerTag {
	return v.value
}

func (v *NullableMessengerTag) Set(val *MessengerTag) {
	v.value = val
	v.isSet = true
}

func (v NullableMessengerTag) IsSet() bool {
	return v.isSet
}

func (v *NullableMessengerTag) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessengerTag(val *MessengerTag) *NullableMessengerTag {
	return &NullableMessengerTag{value: val, isSet: true}
}

func (v NullableMessengerTag) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessengerTag) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

